%******************************************************************
%MATINI....2
% TVORBA ADMITANCNI MATICE A INICIACE VEKTORU
%	vetev s obecnym prenosem
Ykm=1 ./(R+i*X);		
Ykm=Ykm ./T;
Ykk=(1.-T) ./T .*Ykm;
Ymm=Ykm .*(T-1);
Svod=i*B ./2;			        	% susceptance je u PI clanku polovicni

%	Vytvoreni ridke matice site
Y=sparse(NU,NU);
for Iv = 1:NV			% pro vsechny  vetve
   IZ=ZU(Iv);
   IK=KU(Iv);
  Y(IZ,IZ)=Y(IZ,IZ)+Ykm(Iv)+Ykk(Iv)+Svod(Iv);
  Y(IK,IK)=Y(IK,IK)+Ykm(Iv)+Ymm(Iv)+Svod(Iv);
  Y(IK,IZ)=Y(IK,IZ)-Ykm(Iv);
  Y(IZ,IK)=Y(IZ,IK)-Ykm(Iv);
end
%Vytvoreni pomocnych vektoru
[II,JJ,Yij]=find(Y);		      % do Yij vyber vsechny nenulove prvky
Ym=abs(Yij);
Gama=angle(Yij);              % admitann hel prvk  Y matice
PQPU=TU~=3;                	% PQ a PU uzly bez slack
PQ=TU==1;                   	% uzly PQ
PU=TU==2;          	       	% uzly PU
Slack=TU==3;						% uzel Slack
PUS=TU~=1;                    % uzly typu PU a Slack
IndPQPU=find(PQPU);           % indexy PQ a PU
IndPQ=find(PQ);    		      %  indexy uzlu PQ
IndPU=find(PU);	   	   	%  indexy uzlu PU
IndSlack=find(Slack);
IndPUS=find(PUS);
%nastaveni napeti
Ua=ones(NU,1);                % pocatecni odhad napeti
UhelUzlu=zeros(NU,1);         % pocatecni odhad uhlu
Ua(IndPU)=UW(IndPU);          % nastav kontrolovane napeti PU
Ua(IndSlack)=UW(IndSlack);    % nastav kontrolovane napeti Slack
%deklarace vektoru
vse=1:NU;
UhelVetve=zeros(size(II,1),1);%vektor pro rozdily uhlu na obou koncu vetvi
UUy=zeros(size(II,1),1);   	%  nulovani vektoru souinu napt a vodivosti
PomSpr=1:size(II,1);          %  pomocny vektor ridke matice
KorUhel=zeros(NU,1);          %  vektor korekc hl
KorUa=zeros(NU,1);            %  vektor korekc napt
IndUhel=1:NU-1;               %  indexy vektoru hl
IndUa=1:NU;                   %  indexy vektoru modul napt
LP=-ones(NU,1);               %  vektor L multipliktr vkonu P
%LP(Slack,1)=0;
LQ=zeros(NU,1);
LQ(PQ,1)=0.1*ones(size(IndPQ,1),1);            %  vektor L multipliktr vkonu Q
%TLQ=LQ;
%TLP=LP;
IndLP=1:size(LP(PQPU),1);     %  indexy L multipliktor vkonu P
IndLQ=1:size(LQ(PQ),1);       %  indexy L multipliktor vkonu Q
PosuvU=size(UhelUzlu(PQPU),1); %  posuvy sloek vektoru ve vektoru V
PosuvLP=PosuvU+size(Ua(vse),1);
PosuvLQ=PosuvLP+size(LP(PQPU),1);
%indexy uloen ve vektoru promnnch V
IndUaV=IndUa+PosuvU;           %indexy Ua ve vektoru V
IndLPV=IndLP+PosuvLP;          %indexy LP ve vektoru V
IndLQV=IndLQ+PosuvLQ;          %indexy LQ ve vektoru V
V=[UhelUzlu(PQPU);Ua(vse);LP(PQPU);LQ(PQ)];%iniciace vektoru promnnch
%**********************************************************************
[IV,JV,Vij]=find(V);	
	
   