%*******************************************************************
%JFMCom
%TVORBA JACOBIOVY FUNKCIONALNI MATICE J
% podmatice jakobianu pro sna indexovn pln.. polrn admitance
JPD=sparse(NU,NU);JQD=JPD;JQU=JPD;JPU=JPD;

for Ip=1:size(II,1),		   % pro kad prvek matice Y
   k=II(Ip); m=JJ(Ip); 		% indexy spojench uzl v matici Y 
   ya=Ym(Ip);Dkm=Deltakm(Ip);% modul a uhel prvku matice Y
   if k~=m	% nediagonln prvky
      Sk_Um=Ua(k)*ya*exp(i*Dkm);
      Sk_Dm=-i*Ua(k)*Ua(m)*ya*exp(i*Dkm);
      JPD(k,m)=real(Sk_Dm);
      JPU(k,m)=real(Sk_Um);
      JQD(k,m)=imag(Sk_Dm);
      JQU(k,m)=imag(Sk_Um); 
   else							%diagonln prvky
      Sk_Uk=Sact(k)/Ua(k)+Ua(k)*ya*exp(i*Dkm);
      Sk_Dk=i*(Sact(k)-Ua(k)*Ua(k)*ya*exp(i*Dkm));
      JPD(k,k)=real(Sk_Dk);
      JPU(k,k)=real(Sk_Uk); 
      JQD(k,k)=imag(Sk_Dk); 
      JQU(k,k)=imag(Sk_Uk);
   end
end
% vybrn sprvnch element
J=[JPD(PQPU,PQPU) JPU(PQPU,vse)
   JQD(PQ,PQPU)   JQU(PQ,vse)];	% sestaveni funkcionalni matice

%[ZJ,KJ,Jij]=find(J);	
%cgr=fprintf(fidgr,'             matice J         \n');
%cgr=fprintf(fidgr,'iterace= %-5.0f \n',iterace);
%cgr=fprintf(fidgr,'rad  sloupec          Jij   \n');
%cgr=fprintf(fidgr,'%-5.0f  %-5.0f  %+8.4e  \n',[ZJ  KJ  Jij]');

[ZJPU,KJPU,JPUij]=find(JPU);	
cgr=fprintf(fidgr,'             matice JPU         \n');
cgr=fprintf(fidgr,'iterace= %-5.0f \n',iterace);
cgr=fprintf(fidgr,'rad  sloupec        JPUij   \n');
cgr=fprintf(fidgr,'%-5.0f  %-5.0f  %+8.4e  \n',[ZJPU  KJPU  JPUij]');

[ZJQU,KJQU,JQUij]=find(JQU);	
cgr=fprintf(fidgr,'             matice JQU         \n');
cgr=fprintf(fidgr,'iterace= %-5.0f \n',iterace);
cgr=fprintf(fidgr,'rad  sloupec        JQUij   \n');
cgr=fprintf(fidgr,'%-5.0f  %-5.0f  %+8.4e  \n',[ZJQU  KJQU  JQUij]');

[ZJPD,KJPD,JPDij]=find(JPD);	
cgr=fprintf(fidgr,'             matice JPD         \n');
cgr=fprintf(fidgr,'iterace= %-5.0f \n',iterace);
cgr=fprintf(fidgr,'rad  sloupec        JPDij   \n');
cgr=fprintf(fidgr,'%-5.0f  %-5.0f  %+8.4e  \n',[ZJPD  KJPD  JPDij]');

[ZJQD,KJQD,JQDij]=find(JQD);	
cgr=fprintf(fidgr,'             matice JQD         \n');
cgr=fprintf(fidgr,'iterace= %-5.0f \n',iterace);
cgr=fprintf(fidgr,'rad  sloupec        JQDij   \n');
cgr=fprintf(fidgr,'%-5.0f  %-5.0f  %+8.4e  \n',[ZJQD  KJQD  JQDij]');
%**********************************************************************